# 2006.07.30(Sun) 15:52  2.42a ł Render Layers ̐ݒ肪e
# 2006.08.08(Tue) 22:09  Stepǉ

print "--- Self Anim Render ---"
import Blender
from Blender import Draw, BGL, Object, Window, sys

Title		= 'Self Anim Render'
Version		= 'ver.2006.08.08(Tue) 22:09'
Author		= ' by keines'
VerWidth	= Draw.GetStringWidth(Version+Author)
MainWidth	= VerWidth+Draw.GetStringWidth(Title)

# + Cxgԍ
Event_None	= 0
Event_Path	= 1
Event_Execute	= 2
Event_Exit	= 3

# + {l
SpcWidth	= 20
BaseHeight	= 20
BtnHeight	= 20

FrameMax	= 1000
FrameMin	= 1
FrameWidth	= Draw.GetStringWidth(str(FrameMax))+SpcWidth

StepMin		= 1
StepMax		= 100

scene = Blender.Scene.GetCurrent()
context = scene.getRenderingContext()
BasePath=context.getRenderPath()
BaseName="_"
#context.setRenderPath('E:\\tmp\\')


# + {^֌W
#   - 0:  1:
StrList=[['Frame',0],['Execute',0],['Exit',0]]
StrList_Frame	= 0
StrList_Execute	= 1
StrList_Exit	= 2

for i in range(len(StrList)):
    StrList[i][1]=Draw.GetStringWidth(StrList[i][0])+SpcWidth

#   - 0:{^  1:  2:  3:l
BtnList=[[Draw.Create(1),'Start : ',0,0],[Draw.Create(1),'End : ',0,0],[Draw.Create(BasePath),'Path',0,0],[Draw.Create(BaseName),'BaseName',0,0],[Draw.Create(1),'Step : ',0,0]]
BtnList_Start	= 0 # Number
BtnList_End	= 1 # Number
BtnList_Path	= 2 # String
BtnList_BaseName= 3 # String
BtnList_Step	= 4 # Number
for i in range(len(BtnList)):
    BtnList[i][2]=Draw.GetStringWidth(BtnList[i][1])+SpcWidth

BtnList[BtnList_Start][2]+=FrameWidth

def DrawGui():
    global BtnList
    
    # --- Init Screen ---
    BGL.glClearColor(0.6, 0.6, 0.6, 0.0)
    BGL.glClear(Blender.BGL.GL_COLOR_BUFFER_BIT)
    BGL.glColor3f(0.1, 0.1, 0.15) # Text Color
    # --- Get Screen Size ---
    size=Blender.BGL.Buffer(Blender.BGL.GL_FLOAT, 4)
    Blender.BGL.glGetFloatv(Blender.BGL.GL_SCISSOR_BOX, size)
    size= size.list
    # FLOAT -> INT
    for s in range(4): size[s]=int(size[s])
    # Base Position
    x=20
    y=size[3]-BaseHeight
    # + Title
    BGL.glRasterPos2f(x, y)
    Draw.Text(Title)
    
    #print "Loop"
    #NumberBtn=Draw.Create(100)
    # 0:{^  1:  2:  3:l
    
    #  - StartFrame
    k=BtnList_Start
    w=BtnList[k][2]+2

    p=BtnList_Path
    pw=BtnList[p][2]
    kk=StrList[StrList_Execute][1]+SpcWidth
    ww=w*2
    ww+=kk
    if ww<300:ww=300
    
    MaxWidth=ww
    h=BaseHeight
    
    y-=BaseHeight+10
    for i in range(2):  # BtnList[i][1]
      BtnList[i+p][0]=Draw.String( BtnList[i+p][1]+' >>',Event_None,x+pw,y-(h+4)*i,ww-pw,BtnHeight,BtnList[i+p][0].val,255)
      BtnList[i+k][0]=Draw.Number( BtnList[i+k][1],Event_None,x+w*i,y-h*3-(8*3),w-6, BtnHeight, BtnList[i+k][0].val, FrameMin, FrameMax)
      if i==0:
        Draw.Button(BtnList[i+p][1],Event_Path,x,y,pw-4,BtnHeight,'test')
	pw=0
    
    Draw.Button (StrList[StrList_Execute][0],Event_Execute   ,x+MaxWidth-kk,y-(h+8)*3,kk,BaseHeight,"")
    BtnList[BtnList_Step][0]=Draw.Number( BtnList[BtnList_Step][1],Event_None,x,y-(h+8)*2,w-6, BtnHeight, BtnList[BtnList_Step][0].val, StepMin, StepMax)
    
    # + Exit Button
    y-=(BaseHeight+6)*5
    Draw.Button (StrList[StrList_Exit][0],Event_Exit,x,y,StrList[StrList_Exit][1]+SpcWidth,BaseHeight,"")
    # + Version
    y-=BaseHeight
    BGL.glRasterPos2f(x+MaxWidth-VerWidth, y)
    Draw.Text(Version+Author)

"""
# + IɍČvZ
def UpDateFrame(ObjectName):
  OB=Blender.Object.Get(ObjectName)
  OB.makeDisplayList()
  
  MainPose = Blender.Object.Get("Armature").getPose()
  MainPose.update()
  
  #Window.RedrawAll()
  Blender.Redraw()

Frame=Blender.Get('curframe')
"""

def addSlash(path):
  if path.endswith('\\') or path.endswith('/'):
    return path
  return path + sys.sep

def ExecuteFunction():
  
  WorkPath=addSlash(BtnList[BtnList_Path][0].val)
  if Blender.sys.exists(WorkPath)==2:
    # pX̊mF
    #    0: pX݂Ȃ
    #    1: pXwt@C݂
    #    2: pXwfBNg݂
    #   -1: pX݂͑邪AWt@CłfBNgłȂ
    
    scene=Blender.Scene.getCurrent()
    rc=scene.getRenderingContext()

    # - pXꎞޔ
    MainRenderPath=rc.getRenderPath()
    try:
      
      # - [U[pXݒ
      rc.setRenderPath(WorkPath)
      #print rc.getRenderPath(),'  ,  ',rc.getRenderPath().replace('\\','/')

      BaseName=BtnList[BtnList_BaseName][0].val
      
      StartFrame=BtnList[BtnList_Start][0].val
      EndFrame=BtnList[BtnList_End][0].val
      Step=BtnList[BtnList_Step][0].val
      
      print 'Path :',WorkPath
      print 'Frame: %3d -> %3d (Step%3d)' % (StartFrame,EndFrame,Step)
      StartTime=Blender.sys.time()
      
      for i in range(StartFrame, EndFrame+1,Step):
        
        # - t[Pi߂
        rc.currentFrame(i)
        #Blender.Redraw()
        
        # - _O
        time1 = Blender.sys.time()
        rc.render()
        
        # - o
        s=BaseName+'%03d' % (i)
        rc.saveRenderedImage(s)
        
        print '  Saved: ' + s +' Time: %.3f' % (Blender.sys.time() - time1)
      
      Blender.Scene.Render.CloseRenderWindow()
      #print 'Finish: Time:%.3f\n' % (Blender.sys.time()-StartTime)
      k=Blender.sys.time()-StartTime
      print '  a trifle.. %02d\n' % (k)
    except:
      print '  error..'
    
    # + pXɖ߂
    rc.setRenderPath(MainRenderPath)

# BaseName
def PathSelectFunction(fn):
    BtnList[BtnList_Path][0].val=addSlash(Blender.sys.dirname(fn))

def ButtonEvent(evt):
    if (evt==Event_Execute)	: ExecuteFunction()
    elif (evt==Event_Path)	: Window.FileSelector (PathSelectFunction, 'Path Select..')
    elif (evt==Event_Exit)	: Draw.Exit()

def KeyEvent(evt, val):
    # val: 1=KeyDown 0=KeyUp
    if (not val) :
        return
    if evt in [Draw.ESCKEY, Draw.QKEY]:
        Draw.Exit()

Draw.Register(DrawGui, KeyEvent, ButtonEvent)
